% Calculation of LW, ER, SP and PIR directly from the Klippel NFS raw data 
% 202200615 the ER calculation is not correct and therefore the PIR is wrong


% ------------------------------------------------------------------------------
% Clear variables and house keeping
% ------------------------------------------------------------------------------
clear
close all
clc

% ------------------------------------------------------------------------------
% Set some variables for the rest of the script
% ------------------------------------------------------------------------------
Pref       = 0.00002;
startRow   = 4;
endRow     = 1000; % Change here for the correct number of lines/rows in the NFS data

% ------------------------------------------------------------------------------
% Load NFS Measurements data Horizontal SPL and Vertical SPL in Octave
% 70 curves (72 minus (ON and 180) which may be measured twice)
% ------------------------------------------------------------------------------
formatSpec = '%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f%[^\n]';
delimiter  = '\t';

fileID     = fopen('SPL Horizontal.txt','r');
SPLH       = textscan(fileID, formatSpec, endRow(1)-startRow(1)+1, 'Delimiter', delimiter,'HeaderLines', startRow(1)-1, 'EndOfLine', '\n');
fclose(fileID);

fileID     = fopen('SPL Vertical.txt','r');
SPLV       = textscan(fileID, formatSpec, endRow(1)-startRow(1)+1, 'Delimiter', delimiter,'HeaderLines', startRow(1)-1, 'EndOfLine', '\n');
f          = SPLH{1,1};
fclose(fileID);

for k = 1 % just hides the calculation of p^2
% -------------------------------------------------------------------------
% Energy 
% -------------------------------------------------------------------------
% SPL = 10*log10( (p/Pref)^2 ); 
% 10. ^ (SPL/10) = (p/Pref)^2;
% p^2 = 10. ^ (SPL/10) * Pref^2;

% Horizontal
ON              = SPLH{1,2};
ONp2            = 10 .^ (ON/10)*Pref^2;
H10deg          = SPLH{1,4};
H10degp2        = 10 .^ (H10deg/10)*Pref^2;
Hneg10deg       = SPLH{1,6};
Hneg10degp2     = 10 .^ (Hneg10deg/10)*Pref^2;
H20deg          = SPLH{1,8};
H20degp2        = 10 .^ (H20deg/10)*Pref^2;
Hneg20deg       = SPLH{1,10};
Hneg20degp2     = 10 .^ (Hneg20deg/10)*Pref^2;
H30deg          = SPLH{1,12};
H30degp2        = 10 .^ (H30deg/10)*Pref^2;
Hneg30deg       = SPLH{1,14};
Hneg30degp2     = 10 .^ (Hneg30deg/10)*Pref^2;
H40deg          = SPLH{1,16};
H40degp2        = 10 .^ (H40deg/10)*Pref^2;
Hneg40deg       = SPLH{1,18};
Hneg40degp2     = 10 .^ (Hneg40deg/10)*Pref^2;
H50deg          = SPLH{1,20};
H50degp2        = 10 .^ (H50deg/10)*Pref^2;
Hneg50deg       = SPLH{1,22};
Hneg50degp2     = 10 .^ (Hneg50deg/10)*Pref^2;
H60deg          = SPLH{1,24};
H60degp2        = 10 .^ (H60deg/10)*Pref^2;
Hneg60deg       = SPLH{1,26};
Hneg60degp2     = 10 .^ (Hneg60deg/10)*Pref^2;
H70deg          = SPLH{1,28};
H70degp2        = 10 .^ (H70deg/10)*Pref^2;
Hneg70deg       = SPLH{1,30};
Hneg70degp2     = 10 .^ (Hneg70deg/10)*Pref^2;
H80deg          = SPLH{1,32};
H80degp2        = 10 .^ (H80deg/10)*Pref^2;
Hneg80deg       = SPLH{1,34};
Hneg80degp2     = 10 .^ (Hneg80deg/10)*Pref^2;
H90deg          = SPLH{1,36};
H90degp2        = 10 .^ (H90deg/10)*Pref^2;
Hneg90deg       = SPLH{1,38};
Hneg90degp2     = 10 .^ (Hneg90deg/10)*Pref^2;
H100deg         = SPLH{1,40};
H100degp2       = 10 .^ (H100deg/10)*Pref^2;
Hneg100deg      = SPLH{1,42};
Hneg100degp2    = 10 .^ (Hneg100deg/10)*Pref^2;
H110deg         = SPLH{1,44};
H110degp2       = 10 .^ (H110deg/10)*Pref^2;
Hneg110deg      = SPLH{1,46};
Hneg110degp2    = 10 .^ (Hneg110deg/10)*Pref^2;
H120deg         = SPLH{1,48};
H120degp2       = 10 .^ (H120deg/10)*Pref^2;
Hneg120deg      = SPLH{1,50};
Hneg120degp2    = 10 .^ (Hneg120deg/10)*Pref^2;
H130deg         = SPLH{1,52};
H130degp2       = 10 .^ (H130deg/10)*Pref^2;
Hneg130deg      = SPLH{1,54};
Hneg130degp2    = 10 .^ (Hneg130deg/10)*Pref^2;
H140deg         = SPLH{1,56};
H140degp2       = 10 .^ (H140deg/10)*Pref^2;
Hneg140deg      = SPLH{1,58};
Hneg140degp2    = 10 .^ (Hneg140deg/10)*Pref^2;
H150deg         = SPLH{1,60};
H150degp2       = 10 .^ (H150deg/10)*Pref^2;
Hneg150deg      = SPLH{1,62};
Hneg150degp2    = 10 .^ (Hneg150deg/10)*Pref^2;
H160deg         = SPLH{1,64};
H160degp2       = 10 .^ (H160deg/10)*Pref^2;
Hneg160deg      = SPLH{1,66};
Hneg160degp2    = 10 .^ (Hneg160deg/10)*Pref^2;
H170deg         = SPLH{1,68};
H170degp2       = 10 .^ (H170deg/10)*Pref^2;
Hneg170deg      = SPLH{1,70};
Hneg170degp2    = 10 .^ (Hneg170deg/10)*Pref^2;
H180deg         = SPLH{1,72};
H180degp2       = 10 .^ (H180deg/10)*Pref^2;

% Vertical
V10deg          = SPLV{1,4};
V10degp2        = 10 .^ (V10deg/10)*Pref^2;
Vneg10deg       = SPLV{1,6};
Vneg10degp2     = 10 .^ (Vneg10deg/10)*Pref^2;
V20deg          = SPLV{1,8};
V20degp2        = 10 .^ (V20deg/10)*Pref^2;
Vneg20deg       = SPLV{1,10};
Vneg20degp2     = 10 .^ (Vneg20deg/10)*Pref^2;
V30deg          = SPLV{1,12};
V30degp2        = 10 .^ (V30deg/10)*Pref^2;
Vneg30deg       = SPLV{1,14};
Vneg30degp2     = 10 .^ (Vneg30deg/10)*Pref^2;
V40deg          = SPLV{1,16};
V40degp2        = 10 .^ (V40deg/10)*Pref^2;
Vneg40deg       = SPLV{1,18};
Vneg40degp2     = 10 .^ (Vneg40deg/10)*Pref^2;
V50deg          = SPLV{1,20};
V50degp2        = 10 .^ (V50deg/10)*Pref^2;
Vneg50deg       = SPLV{1,22};
Vneg50degp2     = 10 .^ (Vneg50deg/10)*Pref^2;
V60deg          = SPLV{1,24};
V60degp2        = 10 .^ (V60deg/10)*Pref^2;
Vneg60deg       = SPLV{1,26};
Vneg60degp2     = 10 .^ (Vneg60deg/10)*Pref^2;
V70deg          = SPLV{1,28};
V70degp2        = 10 .^ (V70deg/10)*Pref^2;
Vneg70deg       = SPLV{1,30};
Vneg70degp2     = 10 .^ (Vneg70deg/10)*Pref^2;
V80deg          = SPLV{1,32};
V80degp2        = 10 .^ (V80deg/10)*Pref^2;
Vneg80deg       = SPLV{1,34};
Vneg80degp2     = 10 .^ (Vneg80deg/10)*Pref^2;
V90deg          = SPLV{1,36};
V90degp2        = 10 .^ (V90deg/10)*Pref^2;
Vneg90deg       = SPLV{1,38};
Vneg90degp2     = 10 .^ (Vneg90deg/10)*Pref^2;
V100deg         = SPLV{1,40};
V100degp2       = 10 .^ (V100deg/10)*Pref^2;
Vneg100deg      = SPLV{1,42};
Vneg100degp2    = 10 .^ (Vneg100deg/10)*Pref^2;
V110deg         = SPLV{1,44};
V110degp2       = 10 .^ (V110deg/10)*Pref^2;
Vneg110deg      = SPLV{1,46};
Vneg110degp2    = 10 .^ (Vneg110deg/10)*Pref^2;
V120deg         = SPLV{1,48};
V120degp2       = 10 .^ (V120deg/10)*Pref^2;
Vneg120deg      = SPLV{1,50};
Vneg120degp2    = 10 .^ (Vneg120deg/10)*Pref^2;
V130deg         = SPLV{1,52};
V130degp2       = 10 .^ (V130deg/10)*Pref^2;
Vneg130deg      = SPLV{1,54};
Vneg130degp2    = 10 .^ (Vneg130deg/10)*Pref^2;
V140deg         = SPLV{1,56};
V140degp2       = 10 .^ (V140deg/10)*Pref^2;
Vneg140deg      = SPLV{1,58};
Vneg140degp2    = 10 .^ (Vneg140deg/10)*Pref^2;
V150deg         = SPLV{1,60};
V150degp2       = 10 .^ (V150deg/10)*Pref^2;
Vneg150deg      = SPLV{1,62};
Vneg150degp2    = 10 .^ (Vneg150deg/10)*Pref^2;
V160deg         = SPLV{1,64};
V160degp2       = 10 .^ (V160deg/10)*Pref^2;
Vneg160deg      = SPLV{1,66};
Vneg160degp2    = 10 .^ (Vneg160deg/10)*Pref^2;
V170deg         = SPLV{1,68};
V170degp2       = 10 .^ (V170deg/10)*Pref^2;
Vneg170deg      = SPLV{1,70};
Vneg170degp2    = 10 .^ (Vneg170deg/10)*Pref^2;
end


% ------------------------------------------------------------------------------
% Load NFS calculated CEA2034 data in Octave
% ------------------------------------------------------------------------------
formatSpec = '%f%f%f%f%f%f%f%f%f%f%f%f%f%f%[^\n]';
delimiter  = '\t';

fileID     = fopen('CEA2034.txt','r');
CEA2034    = textscan(fileID, formatSpec, endRow(1)-startRow(1)+1, 'Delimiter', delimiter, 'HeaderLines', startRow(1)-1, 'ReturnOnError', false, 'EndOfLine', '\n');
fclose(fileID);

f          = CEA2034{1,1};
ON_NFS     = CEA2034{1,2};
LW_NFS     = CEA2034{1,4};
ER_NFS     = CEA2034{1,6};
SP_NFS     = CEA2034{1,8};
SPDI_NFS   = CEA2034{1,10};
ERDI_NFS   = CEA2034{1,12};
DIoffset   = CEA2034{1,14};

% ------------------------------------------------------------------------------
% Load NFS calculated PIR data in Octave
% ------------------------------------------------------------------------------
formatSpec = '%f%f%[^\n]';
delimiter  = '\t';

fileID     = fopen('Estimated In-Room Response.txt','r');
PIRdata    = textscan(fileID, formatSpec, endRow(1)-startRow(1)+1, 'Delimiter', delimiter, 'HeaderLines', startRow(1)-1, 'ReturnOnError', false, 'EndOfLine', '\n');
fclose(fileID);

% f          = CEA2034{1,1};
PIR_NFS    = PIRdata{1,2};

% ------------------------------------------------------------------------------
% Plot NFS CEA2034 Measurements data and NFS PIR
% ------------------------------------------------------------------------------
figure(1)
set(gcf,'Name','NFS Complete Data')
    semilogx(f,ON_NFS,'color', 'g','LineWidth',2)
    hold on
    semilogx(f,LW_NFS,'color', 'b','LineWidth',2)
    semilogx(f,ER_NFS,'color', 'k','LineWidth',2)
    semilogx(f,PIR_NFS   ,'color', 'y','LineWidth',2)
    semilogx(f,SP_NFS,'color', 'c','LineWidth',2)
    semilogx(f,SPDI_NFS+20,'color', 'r','LineWidth',2)
    semilogx(f,ERDI_NFS+20,'color', 'm','LineWidth',2)
    legend('ON NFS', 'LW NFS', 'ER NFS', 'PIR NFS', 'SP NFS', 'SPDI NFS', 'EXDI NFS', 'location','northwest')
    ylabel('SPL [dB]','Fontsize',14)
    xlabel('Frequency [Hz]','Fontsize',14)
    grid on
    title('Kali IN8 Spinorama NFS data','Fontsize',16)
    xlim([20 20000])
    ylim([round(mean(DIoffset)+20)  100])

% ------------------------------------------------------------------------------
% LW: Listening Window calculation
% LW  0,  +/-10h, +/-20h, +/-30h, +/-10v do energy average of the 9 curves 
% ------------------------------------------------------------------------------
LW_calc    = 10*log10(((1 * ONp2 + ...
                           1 * H10degp2 + ...
                           1 * Hneg10degp2 + ...
                           1 * H20degp2 + ...
                           1 * Hneg20degp2 + ...
                           1 * H30degp2 + ...
                           1 * Hneg30degp2 + ...
                           1 * V10degp2 + ...
                           1 * Vneg10degp2) / 9 ) / Pref^2);
figure(2)
set(gcf,'Name','LW Data')
    semilogx(f,LW_NFS   , 'k','LineWidth',2)
    hold on
    semilogx(f,LW_calc  , 'r--','LineWidth',2)
    legend('LW NFS','LW direct calculation', 'location','northwest')
    ylabel('SPL [dB]','Fontsize',14)
    xlabel('Frequency [Hz]','Fontsize',14)
    grid on
    title('LW data','Fontsize',16)
    xlim([20 20000])                      
%    ylim([80 95])
    ylim([round(mean(DIoffset))  100])

% ------------------------------------------------------------------------------
% ER: Early Reflexions calculation
% Floor:     -20v, -30v, -40v do energy average of the 3 curves                                            
% Ceiling:   +40v, +50v, +60v do energy average of the 3 curves 
% Front Wall:  0,  +/-10h, +/-20h, +/-0h do energy average of the 7 curves 
% Side Wall: +/-40h,  +/-50h,  +/-60h,  +/-70h,  +/-80h do energy average  of the 10 curves 
% Rear Wall: +/-90h   +/-100h, +/-110h, +/-120h, +/-130h, +/-140h, +/-150h, +/-160h, +/-170h, 180 
% do energy average of the 19 curves
% ------------------------------------------------------------------------------
Floor_bounce      = 10*log10( (Vneg20degp2 + Vneg30degp2  + Vneg40degp2 ) / 3 / Pref^2); 

Ceiling_bounce    = 10*log10( (V40degp2    + V50degp2     + V60degp2    ) / 3 / Pref^2); 

Front_wall_bounce = 10*log10( (ONp2        + H10degp2     + Hneg10degp2 + Hneg20degp2  + H20degp2  + Hneg30degp2  + ...
                               H30degp2 ) / 7 / Pref^2);

Side_wall_bounce  = 10*log10( (H40degp2    + Hneg40degp2  + H50degp2    + Hneg50degp2  + H60degp2  + Hneg60degp2  + ...
                               H70degp2    + Hneg70degp2  + H80degp2    + Hneg80degp2 ) / 10 / Pref^2);
 
Rear_wall_bounce  = 10*log10( (H90degp2    + Hneg90degp2  + H100degp2   + Hneg100degp2 + H110degp2 + Hneg110degp2 + ...
                               H120degp2   + Hneg120degp2 + H130degp2   + Hneg130degp2 + H140degp2 + Hneg140degp2 + ...
                               H150degp2   + Hneg150degp2 + H160degp2   + Hneg160degp2 + H170degp2 + Hneg170degp2 + ...
                               H180degp2 ) / 19 / Pref^2);
                                                      
ER_calc   =  10*log10( (10 .^ (Floor_bounce/10)*Pref^2      + 10 .^ (Ceiling_bounce/10)*Pref^2   + ...
                        10 .^ (Front_wall_bounce/10)*Pref^2 + 10 .^ (Side_wall_bounce/10)*Pref^2 + ...
                        10 .^ (Rear_wall_bounce/10)*Pref^2 ) / 5 / Pref^2);

ERDI_calc = LW_calc - ER_calc;

figure(3)
set(gcf,'Name','ER Data')
    semilogx(f,ER_NFS   , 'k','LineWidth',2)
    hold on
    semilogx(f,ER_calc  , 'r--','LineWidth',2)
    semilogx(f,Floor_bounce  , 'm','LineWidth',2)
    semilogx(f,Ceiling_bounce  , 'c','LineWidth',2)
    semilogx(f,Front_wall_bounce  , 'g','LineWidth',2)
    semilogx(f,Side_wall_bounce  , 'b','LineWidth',2)
    semilogx(f,Rear_wall_bounce  , 'color', [0.8 0.8 0.8], 'LineWidth',2) 
    legend('ER NFS','ER direct correct calculation', 'Floor bounce', ...
           'Ceiling bounce', 'Front wall bounce', 'Side wall bounce',...
           'Rear wall bounce', 'location','northeastoutside')
    ylabel('SPL [dB]','Fontsize',14)
    xlabel('Frequency [Hz]','Fontsize',14)
    grid on
    title('ER data','Fontsize',16)
    xlim([20 20000])   
    ylim([round(mean(DIoffset))  100])

% ------------------------------------------------------------------------------
% SP: Sound Power calculation
% Energy average of p^2 sum(Weight*(P/Pref)^2)/sum(w)
% weights are applied to V and H
% ------------------------------------------------------------------------------
W = [
0.0006044860 % 00 & 180deg               - 2
0.0047301890 % +/-10 & +/-170deg V and H - 8
0.0089550270 % +/-20 & +/-160deg V and H - 8
0.0123873540 % +/-30 & +/-150deg V and H - 8
0.0149896110 % +/-40 & +/-140deg V and H - 8
0.0168681540 % +/-50 & +/-130deg V and H - 8
0.0181659620 % +/-60 & +/-120deg V and H - 8
0.0190067440 % +/-70 & +/-110deg V and H - 8
0.0194777870 % +/-80 & +/-100deg V and H - 8
0.0196293730 % +/-90deg          V and H - 4
]; 

SP_calc = 10*log10( (W(1)*ONp2 + ... % Axis (only once!)
 W(2)*H10degp2  + W(2)*Hneg10degp2  + W(3)*H20degp2  + W(3)*Hneg20degp2  + W(4)*H30degp2  + W(4)*Hneg30degp2  + ...
 W(5)*H40degp2  + W(5)*Hneg40degp2  + W(6)*H50degp2  + W(6)*Hneg50degp2  + W(7)*H60degp2  + W(7)*Hneg60degp2  + ... 
 W(8)*H70degp2  + W(8)*Hneg70degp2  + W(9)*H80degp2  + W(9)*Hneg80degp2  + W(10)*H90degp2 + W(10)*Hneg90degp2 + ...
 W(9)*H100degp2 + W(9)*Hneg100degp2 + W(8)*H110degp2 + W(8)*Hneg110degp2 + W(7)*H120degp2 + W(7)*Hneg120degp2 + ...
 W(6)*H130degp2 + W(6)*Hneg130degp2 + W(5)*H140degp2 + W(5)*Hneg140degp2 + W(4)*H150degp2 + W(4)*Hneg150degp2 + ...
 W(3)*H160degp2 + W(3)*Hneg160degp2 + W(2)*H170degp2 + W(2)*Hneg170degp2 + ... % Horizontal
 W(1)*H180degp2 + ...  % Back (only once!)
 W(2)*V10degp2  + W(2)*Vneg10degp2  + W(3)*V20degp2  + W(3)*Vneg20degp2  + W(4)*V30degp2  + W(4)*Vneg30degp2  + ...
 W(5)*V40degp2  + W(5)*Vneg40degp2  + W(6)*V50degp2  + W(6)*Vneg50degp2  + W(7)*V60degp2  + W(7)*Vneg60degp2  + ... 
 W(8)*V70degp2  + W(8)*Vneg70degp2  + W(9)*V80degp2  + W(9)*Vneg80degp2  + W(10)*V90degp2 + W(10)*Vneg90degp2 + ...
 W(9)*V100degp2 + W(9)*Vneg100degp2 + W(8)*V110degp2 + W(8)*Vneg110degp2 + W(7)*V120degp2 + W(7)*Vneg120degp2 + ...
 W(6)*V130degp2 + W(6)*Vneg130degp2 + W(5)*V140degp2 + W(5)*Vneg140degp2 + W(4)*V150degp2 + W(4)*Vneg150degp2 + ...
 W(3)*V160degp2 + W(3)*Vneg160degp2 + W(2)*V170degp2 + W(2)*Vneg170degp2) / ... % Vertical
( 2*W(1) + 8*W(2) + 8*W(3) + 8*W(4) + 8*W(5) + 8*W(6) + 8*W(7) + 8*W(8) + 8*W(9) + 4*W(10) ) / Pref^2); % Sum weights

figure(4)
set(gcf,'Name','SP Data')
    semilogx(f,SP_NFS   , 'k','LineWidth',2)
    hold on
    semilogx(f,SP_calc  , 'r--','LineWidth',2)
    legend('SP NFS','SP direct Calculation', 'location','northwest')
    ylabel('SPL [dB]','Fontsize',14)
    xlabel('Frequency [Hz]','Fontsize',14)
    grid on
    title('All data','Fontsize',16)
    xlim([20 20000]) 
 %   ylim([80 95])
    ylim([round(mean(DIoffset))  100])


% ------------------------------------------------------------------------------
% PIR: predicted In-room Response calculation
% PIR: 0.12LW + 0.44ER + 0.44SP do energy average of the 3 curves
% Plot PIR Slope 100 - 16000Hz
% ------------------------------------------------------------------------------
 
% PIR from the NFS ER data
PIR_calc_NFS  = 10*log10(( 0.12 * 10 .^ (LW_NFS/10) * Pref^2 + ... 
                           0.44 * 10 .^ (ER_NFS/10) * Pref^2 + ... 
                           0.44 * 10 .^ (SP_NFS/10) * Pref^2 ) / Pref^2 ) ; 

% PIR from the direct calculation data
PIR_calc_calc = 10*log10(( 0.12 * 10 .^ (LW_calc/10) * Pref^2 + ...
                           0.44 * 10 .^ (ER_calc/10) * Pref^2 + ...
                           0.44 * 10 .^ (SP_calc/10) * Pref^2 ) / Pref^2 ) ;
 
[~,flowindx]  = min(abs(f-100));
[~,fhigindx]  = min(abs(f-16000));
[P,S]         = polyfit(log(f(flowindx+1:fhigindx)), PIR_calc_calc(flowindx+1:fhigindx), 1);
Regression    = P(2) + P(1)*log(f(flowindx+1:fhigindx));                           

figure(5)
set(gcf,'Name','PIR Data')
    semilogx(f, PIR_NFS   , 'k','LineWidth',2)
    hold on
    semilogx(f, PIR_calc_NFS  , 'r--','LineWidth',2)
    semilogx(f, PIR_calc_calc  , 'b','LineWidth',2)
    semilogx(f(flowindx+1:fhigindx), Regression , 'g','LineWidth',2)
    legend('PIR NFS', 'PIR calculated from NFS data', 'PIR direct calculation', 'Slope', 'location','northeast')
    ylabel('SPL [dB]','Fontsize',14)
    xlabel('Frequency [Hz]','Fontsize',14)
    grid on
    title('All data','Fontsize',16)
    xlim([20 20000])
%    ylim([81 93])
    ylim([round(mean(DIoffset))  100])

% ------------------------------------------------------------------------------
% Update the figure(1) with the corrected ER and PIR data for comparison
% ------------------------------------------------------------------------------
figure(1)
set(gcf,'Name','NFS Complete Data')
    semilogx(f,ER_calc        , 'color', [0.8 0.8 0.8],'LineWidth',2)
    semilogx(f,PIR_calc_calc  , 'color', [1 0.5 0],'LineWidth',2)
    semilogx(f,LW_calc - ER_calc + DIoffset + 20 , 'color', [0 0.5 1],'LineWidth',2)   
    legend('ON NFS', 'LW NFS', 'ER NFS', 'PIR NFS', 'SP NFS', 'SPDI NFS', 'ERDI NFS',...
           'ER direct calculation', 'PIR direct calculation', 'ERDI direct calculation', 'location','northeastoutside')

% ------------------------------------------------------------------------------
% Save the corrected Spinorama + PIR with the corrected ER and PIR 
% plot the corrected Spinorama + PIR corrected data only
% Save the corresponding graph
% ------------------------------------------------------------------------------
    
    Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI = [f ON_NFS LW_NFS ER_calc PIR_calc_calc SP_NFS SPDI_NFS (ERDI_calc+DIoffset)];
    save Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI.mat Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI

    
%     Spininorama_corrected_IN8_F_ON_LW_ER_PIR_SP_SPDI_ERDI = [f ON_NFS LW_NFS ER_calc PIR_calc_calc SP_NFS SPDI_NFS (ERDI_calc+DIoffset)];
%     save Spininorama_corrected_IN8_F_ON_LW_ER_PIR_SP_SPDI_ERDI.mat Spininorama_corrected_IN8_F_ON_LW_ER_PIR_SP_SPDI_ERDI
    
figure(6)
set(gcf,'Name','Spinorama Corrected Data')
    semilogx(Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,1),Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,2),'k','LineWidth',2)
    hold on
    semilogx(Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,1),Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,3),'g','LineWidth',2)
    semilogx(Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,1),Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,4),'r','LineWidth',2)
    semilogx(Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,1),Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,5),'c','LineWidth',2)
    semilogx(Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,1),Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,6),'b','LineWidth',2)
    semilogx(Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,1),Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,7),'color',[0.5 0.0 0.5],'LineWidth',2)
    semilogx(Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,1),Spininorama_corrected_F_ON_LW_ER_PIR_SP_SPDI_ERDI(:,8),'color',[1.0 0.5 0.0],'LineWidth',2)
    legend('ON', 'LW', 'ER', 'PIR', 'SP', 'SPDI + 50dB', 'ERDI + 50dB','location','northeastoutside')
    ylabel('SPL [dB]','Fontsize',14)
    xlabel('Frequency [Hz]','Fontsize',14)
    grid on
    title('Spinorama Correct data','Fontsize',16)
    xlim([20 20000])
 %   ylim([50 95])
    ylim([round(mean(DIoffset))  100])
    print(gcf, '-dpng', 'Corrected Spininorama.png') 


% ------------------------------------------------------------------------------
% End of script
% ------------------------------------------------------------------------------
 

    

    



